---

- name: UnHold Docker apt packages
  ansible.builtin.dpkg_selections:
    name: "{{ item }}"
    selection: install
  loop:
    - docker-ce
    - docker-ce-cli

- name: Configure docker daemon with live-restore
  ansible.builtin.template:
    src: daemon.json.j2
    dest: "/etc/docker/daemon.json"
    mode: "0644"
  vars:
    live_restore: "true"

- name: Get dockerd service
  ansible.builtin.command: pgrep dockerd
  register: pids_of_dockerd
  changed_when: false

- name: Reload Docker Daemon Config
  ansible.builtin.command: "sudo kill -SIGHUP {{ pids_of_dockerd.stdout }}"
  changed_when: false

- name: Install docker CE (apt)
  ansible.builtin.apt:
    name: "{{ item }}={{ docker_deb_pkg_version }}"
    state: present
    allow_downgrade: "{{ docker_allow_version_change | bool }}"
    allow_change_held_packages: "{{ docker_allow_version_change | bool }}"
  loop: "{{ docker_deb_pkgs }}"

- name: Hold Docker apt packages
  ansible.builtin.dpkg_selections:
    name: "{{ item }}"
    selection: hold
  loop: "{{ docker_deb_pkgs }}"

- name: Reload systemd
  ansible.builtin.systemd:
    daemon_reload: true

- name: Configure docker daemon with live-restore
  ansible.builtin.template:
    src: daemon.json.j2
    dest: "/etc/docker/daemon.json"
    mode: "0644"

- name: Get dockerd service
  ansible.builtin.command: pgrep dockerd
  register: pids_of_dockerd
  changed_when: false

- name: Reload Docker Daemon Config
  ansible.builtin.command: "sudo kill -SIGHUP {{ pids_of_dockerd.stdout }}"
  changed_when: false
